Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1787)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1788)
@@ -1891,19 +1894,19 @@
 #if defined( __parallel )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( ngp_2dh_l(0), ngp_2dh(0), sr, MPI_INTEGER, MPI_SUM,   &
+    CALL MPI_ALLREDUCE( ngp_2dh_l(0), ngp_2dh(0), sr, MPI_INTEGER, MPI_SUM,    &
                         comm2d, ierr )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( ngp_2dh_outer_l(0,0), ngp_2dh_outer(0,0), (nz+2)*sr,  &
+    CALL MPI_ALLREDUCE( ngp_2dh_outer_l(0,0), ngp_2dh_outer(0,0), (nz+2)*sr,   &
                         MPI_INTEGER, MPI_SUM, comm2d, ierr )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( ngp_2dh_s_inner_l(0,0), ngp_2dh_s_inner(0,0),         &
+    CALL MPI_ALLREDUCE( ngp_2dh_s_inner_l(0,0), ngp_2dh_s_inner(0,0),          &
                         (nz+2)*sr, MPI_INTEGER, MPI_SUM, comm2d, ierr )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( ngp_3d_inner_l(0), ngp_3d_inner_tmp(0), sr, MPI_REAL, &
+    CALL MPI_ALLREDUCE( ngp_3d_inner_l(0), ngp_3d_inner_tmp(0), sr, MPI_REAL,  &
                         MPI_SUM, comm2d, ierr )
     ngp_3d_inner = INT( ngp_3d_inner_tmp, KIND = SELECTED_INT_KIND( 18 ) )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( mean_surface_level_height_l(0),                       &
-                        mean_surface_level_height(0), sr, MPI_REAL,           &
+    CALL MPI_ALLREDUCE( mean_surface_level_height_l(0),                        &
+                        mean_surface_level_height(0), sr, MPI_REAL,            &
                         MPI_SUM, comm2d, ierr )
     mean_surface_level_height = mean_surface_level_height / REAL( ngp_2dh )
@@ -1924,9 +1927,9 @@
 !-- the respective subdomain lie below the surface topography
     ngp_2dh_outer   = MAX( 1, ngp_2dh_outer(:,:)   ) 
-    ngp_3d_inner    = MAX( INT(1, KIND = SELECTED_INT_KIND( 18 )),            &
+    ngp_3d_inner    = MAX( INT(1, KIND = SELECTED_INT_KIND( 18 )),             &
                            ngp_3d_inner(:) )
     ngp_2dh_s_inner = MAX( 1, ngp_2dh_s_inner(:,:) ) 
 
-    DEALLOCATE( mean_surface_level_height_l, ngp_2dh_l, ngp_2dh_outer_l,      &
+    DEALLOCATE( mean_surface_level_height_l, ngp_2dh_l, ngp_2dh_outer_l,       &
                 ngp_3d_inner_l, ngp_3d_inner_tmp )
 
Index: palm/trunk/SOURCE/land_surface_model.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model.f90	(revision 1787)
+++ palm/trunk/SOURCE/land_surface_model.f90	(revision 1788)
@@ -19,6 +19,15 @@
 ! Current revisions:
 ! -----------------
+! Bugfix: calculate lambda_surface based on temperature gradient between skin
+! layer and soil layer instead of Obukhov length
+! Changed: moved calculation of surface specific humidity to energy balance solver
+! New: water surfaces are available by using a fixed sea surface temperature.
+! The roughness lengths are calculated dynamically using the Charnock 
+! parameterization. This involves the new roughness length for moisture z0q.
+! New: modified solution of the energy balance solver and soil model for
+! paved surfaces (i.e. asphalt concrete).
+! Syntax layout improved.
+! Changed: parameter dewfall removed.
 ! 
-!
 ! Former revisions:
 ! -----------------
@@ -105,5 +114,5 @@
 !> @todo Consider partial absorption of the net shortwave radiation by the 
 !>       skin layer.
-!> @todo Allow for water surfaces
+!> @todo Improve surface water parameterization
 !> @todo Invert indices (running from -3 to 0. Currently: nzb_soil=0, 
 !>       nzt_soil=3)).
@@ -118,5 +127,6 @@
  
     USE arrays_3d,                                                             &
-        ONLY:  hyp, ol, pt, pt_p, q, q_p, ql, qsws, shf, ts, us, vpt, z0, z0h
+        ONLY:  hyp, ol, pt, pt_p, q, q_p, ql, qsws, shf, ts, us, vpt, z0, z0h, &
+               z0q
 
     USE cloud_parameters,                                                      &
@@ -171,9 +181,15 @@
 !
 !-- LSM variables
-    INTEGER(iwp) :: veg_type  = 2, & !< vegetation type, 0: user-defined, 1-19: generic (see list)
-                    soil_type = 3    !< soil type, 0: user-defined, 1-6: generic (see list)
+    INTEGER(iwp) :: veg_type  = 2, & !< NAMELIST veg_type_2d
+                    soil_type = 3    !< NAMELIST soil_type_2d
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  soil_type_2d, &  !< soil type, 0: user-defined, 1-7: generic (see list)
+                                                  veg_type_2d      !< vegetation type, 0: user-defined, 1-19: generic (see list)
+
+    LOGICAL, DIMENSION(:,:), ALLOCATABLE :: water_surface,     & !< flag parameter for water surfaces (classes 14+15)
+                                            pave_surface,      & !< flag parameter for pavements (asphalt etc.) (class 20)
+                                            building_surface     !< flag parameter indicating that the surface element is covered by buildings (no LSM actions, not implemented yet)
 
     LOGICAL :: conserve_water_content = .TRUE.,  & !< open or closed bottom surface for the soil model
-               dewfall = .TRUE.,                 & !< allow/inhibit dewfall
                force_radiation_call_l = .FALSE., & !< flag parameter for unscheduled radiation model calls
                land_surface = .FALSE.              !< flag parameter indicating wheather the lsm is used
@@ -200,4 +216,7 @@
                 m_total = 0.0_wp,                       & !< weighted total water content of the soil (m3/m3)
                 n_vangenuchten = 9999999.9_wp,          & !< NAMELIST n_vg
+                pave_depth = 9999999.9_wp,              & !< depth of the pavement
+                pave_heat_capacity = 1.94E6_wp,         & !< volumetric heat capacity of pavement (e.g. roads)
+                pave_heat_conductivity = 1.00_wp,       & !< heat conductivity for pavements (e.g. roads)
                 q_s = 0.0_wp,                           & !< saturation specific humidity
                 residual_moisture = 9999999.9_wp,       & !< NAMELIST m_res
@@ -210,5 +229,6 @@
                 wilting_point = 9999999.9_wp,           & !< NAMELIST m_wilt
                 z0_eb  = 9999999.9_wp,                  & !< NAMELIST z0 (lsm_par)
-                z0h_eb = 9999999.9_wp                     !< NAMELIST z0h (lsm_par)
+                z0h_eb = 9999999.9_wp,                  & !< NAMELIST z0h (lsm_par)
+                z0q_eb = 9999999.9_wp                     !< NAMELIST z0q (lsm_par)
 
     REAL(wp), DIMENSION(nzb_soil:nzt_soil) :: &
@@ -295,7 +315,7 @@
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
-              lambda_h, &   !< heat conductivity of soil (?)                            
+              lambda_h, &   !< heat conductivity of soil (W/m/K)                            
               lambda_w, &   !< hydraulic diffusivity of soil (?)
-              gamma_w,  &   !< hydraulic conductivity of soil (?)
+              gamma_w,  &   !< hydraulic conductivity of soil (W/m/K)
               rho_c_total   !< volumetric heat capacity of the actual soil matrix (?) 
 
@@ -327,5 +347,5 @@
 !
 !-- Predefined Land surface classes (veg_type)
-    CHARACTER(26), DIMENSION(0:19), PARAMETER :: veg_type_name = (/ &
+    CHARACTER(26), DIMENSION(0:20), PARAMETER :: veg_type_name = (/ &
                                    'user defined              ',    & ! 0 
                                    'crops, mixed farming      ',    & !  1
@@ -347,5 +367,6 @@
                                    'deciduous shrubs          ',    & ! 17
                                    'mixed forest/woodland     ',    & ! 18
-                                   'interrupted forest        '     & ! 19
+                                   'interrupted forest        ',    & ! 19
+                                   'pavements/roads           '     & ! 20
                                                                  /)
 
@@ -368,5 +389,5 @@
 !-- Land surface parameters I
 !--                          r_canopy_min,     lai,   c_veg,     g_d
-    REAL(wp), DIMENSION(0:3,1:19), PARAMETER :: veg_pars = RESHAPE( (/ &
+    REAL(wp), DIMENSION(0:3,1:20), PARAMETER :: veg_pars = RESHAPE( (/ &
                                  180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp,  & !  1
                                  110.0_wp, 2.00_wp, 0.85_wp, 0.00_wp,  & !  2
@@ -387,34 +408,36 @@
                                  225.0_wp, 1.50_wp, 0.50_wp, 0.00_wp,  & ! 17
                                  250.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,  & ! 18
-                                 175.0_wp, 2.50_wp, 0.90_wp, 0.03_wp   & ! 19
-                                 /), (/ 4, 19 /) )
-
-!
-!-- Land surface parameters II          z0,         z0h
-    REAL(wp), DIMENSION(0:1,1:19), PARAMETER :: roughness_par = RESHAPE( (/ & 
-                                   0.25_wp,  0.25E-2_wp,                    & !  1
-                                   0.20_wp,  0.20E-2_wp,                    & !  2
-                                   2.00_wp,     2.00_wp,                    & !  3
-                                   2.00_wp,     2.00_wp,                    & !  4
-                                   2.00_wp,     2.00_wp,                    & !  5
-                                   2.00_wp,     2.00_wp,                    & !  6
-                                   0.47_wp,  0.47E-2_wp,                    & !  7
-                                  0.013_wp, 0.013E-2_wp,                    & !  8
-                                  0.034_wp, 0.034E-2_wp,                    & !  9
-                                    0.5_wp,  0.50E-2_wp,                    & ! 10
-                                   0.17_wp,  0.17E-2_wp,                    & ! 11
-                                 1.3E-3_wp,   1.3E-4_wp,                    & ! 12
-                                   0.83_wp,  0.83E-2_wp,                    & ! 13
-                                   0.00_wp,  0.00E-2_wp,                    & ! 14
-                                   0.00_wp,  0.00E-2_wp,                    & ! 15
-                                   0.10_wp,  0.10E-2_wp,                    & ! 16
-                                   0.25_wp,  0.25E-2_wp,                    & ! 17
-                                   2.00_wp,  2.00E-2_wp,                    & ! 18
-                                   1.10_wp,  1.10E-2_wp                     & ! 19
-                                 /), (/ 2, 19 /) )
+                                 175.0_wp, 2.50_wp, 0.90_wp, 0.03_wp,  & ! 19
+                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp   & ! 20
+                                 /), (/ 4, 20 /) )
+
+!
+!-- Land surface parameters II          z0,         z0h,         z0q
+    REAL(wp), DIMENSION(0:2,1:20), PARAMETER :: roughness_par = RESHAPE( (/ & 
+                                   0.25_wp,  0.25E-2_wp,  0.25E-2_wp,       & !  1
+                                   0.20_wp,  0.20E-2_wp,  0.20E-2_wp,       & !  2
+                                   2.00_wp,     2.00_wp,     2.00_wp,       & !  3
+                                   2.00_wp,     2.00_wp,     2.00_wp,       & !  4
+                                   2.00_wp,     2.00_wp,     2.00_wp,       & !  5
+                                   2.00_wp,     2.00_wp,     2.00_wp,       & !  6
+                                   0.47_wp,  0.47E-2_wp,  0.47E-2_wp,       & !  7
+                                  0.013_wp, 0.013E-2_wp, 0.013E-2_wp,       & !  8
+                                  0.034_wp, 0.034E-2_wp, 0.034E-2_wp,       & !  9
+                                    0.5_wp,  0.50E-2_wp,  0.50E-2_wp,       & ! 10
+                                   0.17_wp,  0.17E-2_wp,  0.17E-2_wp,       & ! 11
+                                 1.3E-3_wp,   1.3E-4_wp,   1.3E-4_wp,       & ! 12
+                                   0.83_wp,  0.83E-2_wp,  0.83E-2_wp,       & ! 13
+                                   0.00_wp,     0.00_wp,     0.00_wp,       & ! 14
+                                   0.00_wp,     0.00_wp,     0.00_wp,       & ! 15
+                                   0.10_wp,  0.10E-2_wp,  0.10E-2_wp,       & ! 16
+                                   0.25_wp,  0.25E-2_wp,  0.25E-2_wp,       & ! 17
+                                   2.00_wp,  2.00E-2_wp,  2.00E-2_wp,       & ! 18
+                                   1.10_wp,  1.10E-2_wp,  1.10E-2_wp,       & ! 19
+                                 1.0E-4_wp,   1.0E-5_wp,   1.0E-5_wp        & ! 20
+                                 /), (/ 3, 20 /) )
 
 !
 !-- Land surface parameters III lambda_surface_s, lambda_surface_u, f_sw_in
-    REAL(wp), DIMENSION(0:2,1:19), PARAMETER :: surface_pars = RESHAPE( (/ &
+    REAL(wp), DIMENSION(0:2,1:20), PARAMETER :: surface_pars = RESHAPE( (/ &
                                       10.0_wp,       10.0_wp, 0.05_wp,     & !  1
                                       10.0_wp,       10.0_wp, 0.05_wp,     & !  2
@@ -430,15 +453,16 @@
                                       58.0_wp,       58.0_wp, 0.00_wp,     & ! 12
                                       10.0_wp,       10.0_wp, 0.05_wp,     & ! 13 
-                                    1.0E20_wp,     1.0E20_wp, 0.00_wp,     & ! 14
-                                    1.0E20_wp,     1.0E20_wp, 0.00_wp,     & ! 15
+                                    1.0E10_wp,     1.0E10_wp, 0.00_wp,     & ! 14
+                                    1.0E10_wp,     1.0E10_wp, 0.00_wp,     & ! 15
                                       10.0_wp,       10.0_wp, 0.05_wp,     & ! 16
                                       10.0_wp,       10.0_wp, 0.05_wp,     & ! 17
                                       20.0_wp,       15.0_wp, 0.03_wp,     & ! 18
-                                      20.0_wp,       15.0_wp, 0.03_wp      & ! 19
-                                      /), (/ 3, 19 /) )
+                                      20.0_wp,       15.0_wp, 0.03_wp,     & ! 19
+                                       0.0_wp,        0.0_wp, 0.00_wp      & ! 20
+                                      /), (/ 3, 20 /) )
 
 !
 !-- Root distribution (sum = 1)  level 1, level 2, level 3, level 4,
-    REAL(wp), DIMENSION(0:3,1:19), PARAMETER :: root_distribution = RESHAPE( (/ &
+    REAL(wp), DIMENSION(0:3,1:20), PARAMETER :: root_distribution = RESHAPE( (/ &
                                  0.24_wp, 0.41_wp, 0.31_wp, 0.04_wp,            & !  1
                                  0.35_wp, 0.38_wp, 0.23_wp, 0.04_wp,            & !  2
@@ -459,6 +483,7 @@
                                  0.23_wp, 0.36_wp, 0.30_wp, 0.11_wp,            & ! 17 
                                  0.19_wp, 0.35_wp, 0.36_wp, 0.10_wp,            & ! 18
-                                 0.19_wp, 0.35_wp, 0.36_wp, 0.10_wp             & ! 19
-                                 /), (/ 4, 19 /) )
+                                 0.19_wp, 0.35_wp, 0.36_wp, 0.10_wp,            & ! 19
+                                 0.00_wp, 0.00_wp, 0.00_wp, 0.00_wp             & ! 20
+                                 /), (/ 4, 20 /) )
 
 !
@@ -499,14 +524,15 @@
 !-- Public parameters, constants and initial values
     PUBLIC alpha_vangenuchten, c_surface, canopy_resistance_coefficient,       &
-           conserve_water_content, dewfall, field_capacity,                    &
+           conserve_water_content, field_capacity,                             &
            f_shortwave_incoming, hydraulic_conductivity, init_lsm,             &
            init_lsm_arrays, lambda_surface_stable, lambda_surface_unstable,    &
            land_surface, leaf_area_index, lsm_energy_balance, lsm_soil_model,  &
            lsm_swap_timelevel, l_vangenuchten, min_canopy_resistance,          &
-           min_soil_resistance, n_vangenuchten, residual_moisture, rho_cp,     &
+           min_soil_resistance, n_vangenuchten, pave_heat_capacity,            &
+           pave_depth, pave_heat_conductivity, residual_moisture, rho_cp,      &
            rho_lv, root_fraction, saturation_moisture, skip_time_do_lsm,       &
            soil_moisture, soil_temperature, soil_type, soil_type_name,         &
            vegetation_coverage, veg_type, veg_type_name, wilting_point, z0_eb, &
-           z0h_eb
+           z0h_eb, z0q_eb
 
 !
@@ -586,4 +612,5 @@
 !--    Allocate 2D vegetation model arrays
        ALLOCATE ( alpha_vg(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( building_surface(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( c_liq(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( c_veg(nysg:nyng,nxlg:nxrg) )
@@ -601,4 +628,5 @@
        ALLOCATE ( m_wilt(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( n_vg(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( pave_surface(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( qsws_eb(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( qsws_soil_eb(nysg:nyng,nxlg:nxrg) )
@@ -613,4 +641,7 @@
        ALLOCATE ( r_canopy_min(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( shf_eb(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( soil_type_2d(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( veg_type_2d(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( water_surface(nysg:nyng,nxlg:nxrg) )
 
 #if ! defined( __nopointer )
@@ -650,5 +681,5 @@
 !
 !--    If no cloud physics is used, rho_surface has not been calculated before
-       IF ( .NOT. cloud_physics )  THEN
+       IF (  .NOT.  cloud_physics )  THEN
           rho_surface = surface_pressure * 100.0_wp / ( r_d * pt_surface * exn )
        ENDIF
@@ -762,4 +793,6 @@
        ENDIF    
 
+!
+!--    Map values to the respective 2D arrays
        alpha_vg      = alpha_vangenuchten
        l_vg          = l_vangenuchten
@@ -796,6 +829,6 @@
 
 !
-!--       Set artifical values for ts and us so that r_a has its initial value for 
-!--       the first time step
+!--       Set artifical values for ts and us so that r_a has its initial value 
+!--       for the first time step
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -864,5 +897,8 @@
              z0h_eb = roughness_par(1,veg_type)
           ENDIF
-          z0h_factor = z0h_eb / z0_eb
+          IF ( z0q_eb == 9999999.9_wp )  THEN
+             z0q_eb = roughness_par(2,veg_type)
+          ENDIF
+          z0h_factor = z0h_eb / ( z0_eb + 1.0E-20_wp )
 
           IF ( ANY( root_fraction == 9999999.9_wp ) )  THEN
@@ -881,9 +917,29 @@
              z0h_eb = z0_eb * z0h_factor
           ENDIF
+          IF ( z0q_eb == 9999999.9_wp )  THEN
+             z0q_eb = z0_eb * z0h_factor
+          ENDIF
 
        ENDIF
 
 !
-!--    Initialize vegetation
+!--    For surfaces covered with pavement, set depth of the pavement (with dry
+!--    soil below). The depth must be greater than the first soil layer depth
+       IF ( veg_type == 20 )  THEN
+          IF ( pave_depth == 9999999.9_wp )  THEN
+             pave_depth = zs(nzb_soil)  
+          ELSE
+             pave_depth = MAX( zs(nzb_soil), pave_depth )
+          ENDIF
+       ENDIF
+
+!
+!--    Map vegetation and soil types to 2D array to allow for heterogeneous 
+!--    surfaces via user interface see below
+       veg_type_2d = veg_type
+       soil_type_2d = soil_type
+
+!
+!--    Map vegetation parameters to the respective 2D arrays
        r_canopy_min         = min_canopy_resistance
        lai                  = leaf_area_index
@@ -895,4 +951,5 @@
        z0                   = z0_eb
        z0h                  = z0h_eb
+       z0q                  = z0q_eb
 
 !
@@ -900,4 +957,22 @@
        CALL user_init_land_surface
 
+!
+!--    Set flag parameter if vegetation type was set to a water surface. Also
+!--    set temperature to a constant value in all "soil" layers.
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
+             IF ( veg_type_2d(j,i) == 14  .OR.  veg_type_2d(j,i) == 15 )  THEN
+                water_surface(j,i) = .TRUE.
+             ELSEIF ( veg_type_2d(j,i) == 20 )  THEN
+                pave_surface(j,i) = .TRUE.
+                m_soil(:,j,i) = 0.0_wp
+             ENDIF
+
+          ENDDO
+       ENDDO
+
+!
+!--    Calculate new roughness lengths (for water surfaces only)
+       CALL calc_z0_water_surface
 
        t_soil_p    = t_soil
@@ -935,5 +1010,6 @@
        INTEGER(iwp) ::  k, ks     !< running index
 
-       REAL(wp) :: f1,          & !< resistance correction term 1
+       REAL(wp) :: c_surface_tmp,& !< temporary variable for storing the volumetric heat capacity of the surface
+                   f1,          & !< resistance correction term 1
                    f2,          & !< resistance correction term 2
                    f3,          & !< resistance correction term 3
@@ -965,9 +1041,19 @@
 
 !
-!--          Set lambda_surface according to stratification
-             IF ( ol(j,i) >= 0.0_wp )  THEN
-                lambda_surface = lambda_surface_s(j,i)
+!--          Set lambda_surface according to stratification between skin layer and soil
+             IF (  .NOT.  pave_surface(j,i) )  THEN
+
+                c_surface_tmp = c_surface
+
+                IF ( t_surface(j,i) >= t_soil(nzb_soil,j,i))  THEN
+                   lambda_surface = lambda_surface_s(j,i)
+                ELSE
+                   lambda_surface = lambda_surface_u(j,i)
+                ENDIF
              ELSE
-                lambda_surface = lambda_surface_u(j,i)
+
+                c_surface_tmp = pave_heat_capacity * dz_soil(nzb_soil) * 0.5_wp
+                lambda_surface = pave_heat_conductivity * ddz_soil(nzb_soil)
+
              ENDIF
 
@@ -1016,5 +1102,5 @@
              ENDDO 
 
-             IF ( m_total > m_wilt(j,i) .AND. m_total < m_fc(j,i) )  THEN
+             IF ( m_total > m_wilt(j,i)  .AND.  m_total < m_fc(j,i) )  THEN
                 f2 = ( m_total - m_wilt(j,i) ) / (m_fc(j,i) - m_wilt(j,i) )
              ELSEIF ( m_total >= m_fc(j,i) )  THEN
@@ -1050,5 +1136,5 @@
 !--          Third step: calculate bare soil resistance r_soil. The Clapp & 
 !--          Hornberger parametrization does not consider c_veg.
-             IF ( soil_type /= 7 )  THEN
+             IF ( soil_type_2d(j,i) /= 7 )  THEN
                 m_min = c_veg(j,i) * m_wilt(j,i) + (1.0_wp - c_veg(j,i)) *     &
                         m_res(j,i)
@@ -1064,8 +1150,18 @@
 
 !
-!--          Calculate fraction of liquid water reservoir
-             m_liq_eb_max = m_max_depth * lai(j,i)
-             c_liq(j,i) = MIN(1.0_wp, m_liq_eb(j,i) / (m_liq_eb_max+1.0E-20_wp))
-             
+!--          Calculate the maximum possible liquid water amount on plants and
+!--          bare surface. For vegetated surfaces, a maximum depth of 0.2 mm is
+!--          assumed, while paved surfaces might hold up 1 mm of water. The 
+!--          liquid water fraction for paved surfaces is calculated after 
+!--          Noilhan & Planton (1989), while the ECMWF formulation is used for
+!--          vegetated surfaces and bare soils.
+             IF ( pave_surface(j,i) )  THEN
+                m_liq_eb_max = m_max_depth * 5.0_wp
+                c_liq(j,i) = MIN( 1.0_wp, (m_liq_eb(j,i) / m_liq_eb_max)**0.67 )
+             ELSE
+                m_liq_eb_max = m_max_depth * ( c_veg(j,i) * lai(j,i)           &
+                               + (1.0_wp - c_veg(j,i)) )
+                c_liq(j,i) = MIN( 1.0_wp, m_liq_eb(j,i) / m_liq_eb_max )
+             ENDIF
 
 !
@@ -1076,5 +1172,5 @@
 !--          In case of dewfall, set evapotranspiration to zero
 !--          All super-saturated water is then removed from the air
-             IF ( humidity .AND. q_s <= qv1 )  THEN
+             IF ( humidity  .AND.  q_s <= qv1 )  THEN
                 r_canopy(j,i) = 0.0_wp
                 r_soil(j,i)   = 0.0_wp
@@ -1083,12 +1179,21 @@
 !
 !--          Calculate coefficients for the total evapotranspiration 
-             f_qsws_veg  = rho_lv * c_veg(j,i) * (1.0_wp - c_liq(j,i))/        &
-                           (r_a(j,i) + r_canopy(j,i))
-
-             f_qsws_soil = rho_lv * (1.0_wp - c_veg(j,i)) / (r_a(j,i) +        &
+!--          In case of water surface, set vegetation and soil fluxes to zero.
+!--          For pavements, only evaporation of liquid water is possible.
+             IF ( water_surface(j,i) )  THEN
+                f_qsws_veg  = 0.0_wp
+                f_qsws_soil = 0.0_wp
+                f_qsws_liq  = rho_lv / r_a(j,i)
+             ELSEIF ( pave_surface (j,i) )  THEN
+                f_qsws_veg  = 0.0_wp
+                f_qsws_soil = 0.0_wp
+                f_qsws_liq  = rho_lv * c_liq(j,i) / r_a(j,i)
+             ELSE
+                f_qsws_veg  = rho_lv * c_veg(j,i) * (1.0_wp - c_liq(j,i))/     &
+                              (r_a(j,i) + r_canopy(j,i))
+                f_qsws_soil = rho_lv * (1.0_wp - c_veg(j,i)) / (r_a(j,i) +     &
                                                           r_soil(j,i))
-             f_qsws_liq  = rho_lv * c_veg(j,i) * c_liq(j,i) / r_a(j,i)
-
-
+                f_qsws_liq  = rho_lv * c_veg(j,i) * c_liq(j,i) / r_a(j,i)
+             ENDIF
 !
 !--          If soil moisture is below wilting point, plants do no longer
@@ -1098,14 +1203,4 @@
 !              ENDIF
 
-!
-!--          If dewfall is deactivated, vegetation, soil and liquid water
-!--          reservoir are not allowed to take up water from the super-saturated
-!--          air.
-             IF ( humidity .AND. q_s <= qv1 .AND. .NOT. dewfall )  THEN
-                f_qsws_veg  = 0.0_wp
-                f_qsws_soil = 0.0_wp
-                f_qsws_liq  = 0.0_wp
-             ENDIF 
-
              f_shf  = rho_cp / r_a(j,i)
              f_qsws = f_qsws_veg + f_qsws_soil + f_qsws_liq
@@ -1123,4 +1218,6 @@
              rad_net_l(j,i) = rad_net(j,i) + rad_lw_out(nzb,j,i)
 
+!
+!--          Calculate new skin temperature
              IF ( humidity )  THEN
 #if defined ( __rrtmg )
@@ -1186,10 +1283,11 @@
 !--          Implicit solution when the surface layer has no heat capacity,
 !--          otherwise use RK3 scheme.
-             t_surface_p(j,i) = ( coef_1 * dt_3d * tsc(2) + c_surface *        &
-                                t_surface(j,i) ) / ( c_surface + coef_2 * dt_3d&
-                                * tsc(2) ) 
+             t_surface_p(j,i) = ( coef_1 * dt_3d * tsc(2) + c_surface_tmp *    &
+                                t_surface(j,i) ) / ( c_surface_tmp + coef_2    &
+                                * dt_3d * tsc(2) ) 
+
 !
 !--          Add RK3 term
-             IF ( c_surface /= 0.0_wp )  THEN
+             IF ( c_surface_tmp /= 0.0_wp )  THEN
 
                 t_surface_p(j,i) = t_surface_p(j,i) + dt_3d * tsc(3)           &
@@ -1211,5 +1309,4 @@
                    ENDIF
                 ENDIF
-
              ENDIF
 
@@ -1223,5 +1320,5 @@
 !--          often reached, when no oscillations would occur (causes immense
 !--          computing time for the radiation code).
-             IF ( ABS( t_surface_p(j,i) - t_surface(j,i) ) > 0.2_wp .AND.      &
+             IF ( ABS( t_surface_p(j,i) - t_surface(j,i) ) > 0.2_wp  .AND.     &
                   unscheduled_radiation_calls )  THEN
                 force_radiation_call_l = .TRUE.
@@ -1249,5 +1346,4 @@
 #endif
 
-
              ghf_eb(j,i)    = lambda_surface * (t_surface_p(j,i)               &
                               - t_soil(nzb_soil,j,i))
@@ -1275,4 +1371,5 @@
                                     * t_surface_p(j,i) )
              ENDIF
+
 !
 !--          Calculate the true surface resistance
@@ -1280,5 +1377,5 @@
                 r_s(j,i) = 1.0E10_wp
              ELSE
-                r_s(j,i) = - rho_lv * ( qv1 - q_s + dq_s_dt                   &
+                r_s(j,i) = - rho_lv * ( qv1 - q_s + dq_s_dt                    &
                            * t_surface(j,i) - dq_s_dt * t_surface_p(j,i) )     &
                            / qsws_eb(j,i) - r_a(j,i)
@@ -1297,5 +1394,7 @@
 !
 !--                Add precipitation to liquid water reservoir, if possible.
-!--                Otherwise, add the water to bare soil fraction.
+!--                Otherwise, add the water to soil. In case of
+!--                pavements, the exceeding water amount is implicitely removed 
+!--                as runoff as qsws_soil_eb is then not used in the soil model
                    IF ( m_liq_eb(j,i) /= m_liq_eb_max )  THEN
                       qsws_liq_eb(j,i) = qsws_liq_eb(j,i)                      &
@@ -1376,5 +1475,5 @@
 !--    Make a logical OR for all processes. Force radiation call if at
 !--    least one processor reached the threshold change in skin temperature
-       IF ( unscheduled_radiation_calls .AND. intermediate_timestep_count      &
+       IF ( unscheduled_radiation_calls  .AND.  intermediate_timestep_count    &
             == intermediate_timestep_count_max-1 )  THEN
 #if defined( __parallel )
@@ -1388,4 +1487,14 @@
        ENDIF
 
+!
+!--    Calculate surface specific humidity
+       IF ( humidity )  THEN
+          CALL calc_q_surface
+       ENDIF
+
+!
+!--    Calculate new roughness lengths (for water surfaces only)
+       CALL calc_z0_water_surface
+
 
     END SUBROUTINE lsm_energy_balance
